

/**
 *
 */

import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.util.List;
import java.util.ArrayList;

public class cc {

	private static final String[] D_ZERO = {
	"+---+",
	"|   |",
	"|   |",
	"+   +",
	"|   |",
	"|   |",
	"+---+",
	};

	private static final String[] D_ONE = {
	"    +",
	"    |",
	"    |",
	"    +",
	"    |",
	"    |",
	"    +",
	};

	private static final String[] D_TWO = {
	"+---+",
	"    |",
	"    |",
	"+---+",
	"|    ",
	"|    ",
	"+---+",
	};

	private static final String[] D_THREE = {
	"+---+",
	"    |",
	"    |",
	"+---+",
	"    |",
	"    |",
	"+---+",
	};

	private static final String[] D_FOUR = {
	"+   +",
	"|   |",
	"|   |",
	"+---+",
	"    |",
	"    |",
	"    +",
	};

	private static final String[] D_FIVE = {
	"+---+",
	"|    ",
	"|    ",
	"+---+",
	"    |",
	"    |",
	"+---+",
	};

	private static final String[] D_SIX = {
	"+---+",
	"|    ",
	"|    ",
	"+---+",
	"|   |",
	"|   |",
	"+---+",
	};

	private static final String[] D_SEVEN = {
	"+---+",
	"    |",
	"    |",
	"    +",
	"    |",
	"    |",
	"    +",
	};

	private static final String[] D_EIGHT = {
	"+---+",
	"|   |",
	"|   |",
	"+---+",
	"|   |",
	"|   |",
	"+---+",
	};


	private static final String[] D_NINE = {
	"+---+",
	"|   |",
	"|   |",
	"+---+",
	"    |",
	"    |",
	"+---+",
	};

	private static final String[] COLON = {
	" ",
	" ",
	"o",
	" ",
	"o",
	" ",
	" ",
	};

	private static final String[] SPACING = {
	"  ",
	"  ",
	"  ",
	"  ",
	"  ",
	"  ",
	"  ",
	};

	private static final String[][] DIGITS = { D_ZERO, D_ONE, D_TWO, D_THREE, D_FOUR, D_FIVE, D_SIX, D_SEVEN, D_EIGHT, D_NINE };

	public static class Clock {
		StringBuffer[] digits = new StringBuffer[4];
		public Clock() {
			for (int i = 0; i < 4; i ++) {
				digits[i] = new StringBuffer();
			}
		}
		public boolean readOneInput(BufferedReader r) throws Exception {
			for (int i = 0; i < 7; i++) {
				String line = r.readLine();
				if (line.startsWith("end")) {
					return false;
				}
				int index = 0;
				for (int j=0; j < 5; j++) {
					digits[0].append(line.charAt(index++));
				}		
				index+=2;
				for (int j=0; j < 5; j++) {
					digits[1].append(line.charAt(index++));
				}		
				index+=5;
				for (int j=0; j < 5; j++) {
					digits[2].append(line.charAt(index++));
				}		
				index+=2;
				for (int j=0; j < 5; j++) {
					digits[3].append(line.charAt(index++));
				}		
			}
			r.readLine();
			r.readLine();
			return true;
		}

		public String representationToString() {
			StringBuffer sb = new StringBuffer();
			for (int i = 0; i < 7; i++) {
				for (int j = 0; j < 4; j++) {
					sb.append(digits[j].charAt(j+(i*5)));
				}
				
			}
			return sb.toString();
		}

		public String toString() {
			int number[] = new int[4];
			List<Integer> d1 = toDigit(digits[0].toString());
			List<Integer> d2 = toDigit(digits[1].toString());
			List<Integer> d3 = toDigit(digits[2].toString());
			List<Integer> d4 = toDigit(digits[3].toString());
			Integer hour = -1;

			for (int i = 0; i < 24; i++) {
				if (d1.contains(i / 10) && (d2.contains(i %10))) {
					if (hour != -1) return "ambiguous";
					hour = i;
				}
			}
			Integer minutes = -1;
			for (int i = 0; i < 60; i++) {
				if (d3.contains(i / 10) && (d4.contains(i %10))) {
					if (minutes != -1) return "ambiguous";
					minutes = i;
				}
			}
			if (hour == -1) return "ambiguous" ;
			if (minutes == -1) return "ambiguous" ;
			String result = "";
			if (hour < 10) {
				result += "0";
			} 
			result += hour + ":";
			if (minutes < 10) {
				result += "0";
			}
			result += minutes;

			return result;
		}

		public boolean compareToDigit(String[] digitDef, String digitString) {
			for (int i = 0; i < 7; i++) {
				for (int j = 0; j < 5; j++) {
					char defChar = digitDef[i].charAt(j);
					char readChar = digitString.charAt(i*5 + j);
					if (readChar != '.' && readChar != defChar) {
						return false;
					}
				}
			}
			return true;
		}

		public List<Integer> toDigit(String digitString) {
			List<Integer> result = new ArrayList<Integer>();
			for (int i = 0; i < 10; i++) {
				if (compareToDigit(DIGITS[i], digitString)) {
					result.add(i);
				}
			}
			return result;
		}
	}

	public static void main(String[] argv) throws Exception {
		BufferedReader r = new BufferedReader(new InputStreamReader(System.in, "US-ASCII"));

		while (true) {
			Clock clock = new Clock();
			if (!clock.readOneInput(r)) {
				System.out.println("end");
				return;
			}
			System.out.println(clock.toString());
		}
	}
}
