import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.util.Arrays;
import java.util.StringTokenizer;
import java.util.Collections;
import java.util.List;
import java.util.ArrayList;

public class pp {


	public static class Input {

		public int[] primes;
		public int min;
		public int max;

		public Input() {
		}

		public boolean read(BufferedReader r) throws Exception {
			String line = r.readLine();
			int cnt = Integer.parseInt(line);
			if (cnt<=0) return false;
			primes = new int[cnt];
			line = r.readLine();
			
			StringTokenizer tok = new StringTokenizer(line);
			int i=0;
			while (tok.hasMoreTokens()) {
				String s = tok.nextToken();
				primes[i] = Integer.parseInt(s);
				i++;
			}

			line = r.readLine();
			tok = new StringTokenizer(line);
			min = Integer.parseInt(tok.nextToken());
			max = Integer.parseInt(tok.nextToken());
			Arrays.sort(primes);
			return true;
		}

		public String toString() {
			return Arrays.toString(primes)+" min="+min+" max="+max;
		}

	}

	public static class State {
		private Input input;
		private int[] exponents;
		private long[][] powers;
		private int curExp;
		private long value;
		private List<Integer> output;
		
		public State(Input input, List<Integer> output) {
			this.input = input;
			this.exponents = new int[input.primes.length];
			this.output = output;
			initPowers();
		}

		private void initPowers() {
			this.powers = new long[input.primes.length][];
			for (int i=0; i<powers.length; i++) {
				long p = input.primes[i];
				long pp = 1;
				long[] pa = new long[32];
				powers[i] = pa;
				int e = 0;
				while (true) {
					pa[e] = pp;
					pp *= p;
					if (pp>input.max)
						break;
					e++;
				}
			}
		}

		public void search() {
			doSearch(1,0);			
			
		}

		protected void doSearch(long from, int expId) {
			long f;
			while (powers[expId][exponents[expId]]>0)  {
				f = from * powers[expId][exponents[expId]];
				//System.out.println("F:"+f+" expId="+expId+" from="+from);
				if (f>input.max) break;
				if (expId==exponents.length-1 && f>1 && f>=input.min) output.add((int)f);
				if (expId<exponents.length-1) doSearch(f,expId+1);
				exponents[expId]++;
			} 
			exponents[expId] = 0;
		}

		public String toString() {
			StringBuilder sb = new StringBuilder();
			for (long[] pa : powers) {
				sb.append(Arrays.toString(pa));
			}
			return sb.toString();
		}
	}
	
	public static void process(Input input) {
		List<Integer> numbers = new ArrayList<Integer>();
		State state = new State(input,numbers);
		state.search();
		if (input.min<2) numbers.add(1);
		Collections.sort(numbers);

		if (numbers.isEmpty()) {
			System.out.println("none");
		}
		else {
			StringBuilder sb = new StringBuilder();
			for (int i=0; i<numbers.size(); i++) {
				if (i>0) sb.append(',');
				sb.append(numbers.get(i));
			}
			System.out.println(sb.toString());
		}
		
		//System.out.println(state.toString());
	}

	public static void main(String[] argv) throws Exception {
		BufferedReader r = new BufferedReader(new InputStreamReader(System.in, "US-ASCII"));
		while (true) {
			Input input = new Input();
			if (!input.read(r))
				break;
			process(input);
		}

	}

}